using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace MQ_Postcard
{
	/// <summary>
	/// Summary description for About.
	/// </summary>
	public class AboutBox : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox listBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		const string qn= "postcard";
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.ListBox listBox2;

		private PostOffice m_po;
		public PostOffice po{
			set { m_po= value; }
		}

		private void AddInfo() {
			if (m_po!=null) {
				IBM.WMQ.MQQueueManager mqm= m_po.mqm;
				try {
					int openOptions= IBM.WMQ.MQC.MQOO_INQUIRE + IBM.WMQ.MQC.MQOO_FAIL_IF_QUIESCING; 
					IBM.WMQ.MQQueue q = mqm.AccessQueue(qn, openOptions);
					int[] selectors= { IBM.WMQ.MQC.MQIA_CURRENT_Q_DEPTH };
					int[] intAttrs=  new int[selectors.Length];
					byte[] byteAttrs= new byte[selectors.Length];
					q.Inquire(selectors, intAttrs, byteAttrs);
					string[]  props1= { 
									   "System Name: " + System.Net.Dns.GetHostName(), 
									   "Platform: " + MQUtils.PlatformToString(mqm.Platform),
//									   "Process: " + mqm_copy.ProcessDescription,
//									   "Id: " + mqm_copy.QueueManagerIdentifier,
									   "Queue Name: " + mqm.Name,
//									   "Desc: " + mqm_copy.QueueManagerDescription,
									   "Created: " + mqm.CreationDateTime.ToString(),
									   "Sync Point Availability: " + mqm.SyncPointAvailability,
						"Queue Name: " + qn,
						"Current Depth: " + intAttrs[0],
					};
					for (int i=0; i < props1.Length; i++) {
						listBox1.Items.Add(props1[i]);
					}
				}
				catch (IBM.WMQ.MQException mqex) {
					MessageBox.Show("Error " + MQUtils.MQExceptionToString(mqex));
				}
			}
			else {
				listBox1.Items.Add("Please connect to a Queue Manager first. ");
			}

			System.Reflection.Assembly caller= System.Reflection.Assembly.GetCallingAssembly();

			//System.Diagnostics.StackTrace st= new System.Diagnostics.StackTrace();

			string[] props2= {
								 caller.GetName().Name + ", Version " + caller.GetName().Version ,
								 "CLR: "  + System.Environment.Version.ToString(), 
				"Running on " + System.Environment.OSVersion.ToString(),
			};
			for (int i=0; i < props2.Length; i++) {
				listBox2.Items.Add(props2[i]);
			}

		}
		new public System.Windows.Forms.DialogResult ShowDialog(System.Windows.Forms.IWin32Window owner) {
			AddInfo();
			//listBox1.Update();
			return base.ShowDialog(owner);
		}

		new public System.Windows.Forms.DialogResult ShowDialog() {
			AddInfo();
			//listBox1.Update();
			return base.ShowDialog();
		}

		public AboutBox()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.listBox2 = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// listBox1
			// 
			this.listBox1.Location = new System.Drawing.Point(8, 208);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(296, 108);
			this.listBox1.TabIndex = 0;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(240, 16);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(64, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "OK";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(192, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "MQ .NET Postcard Test App  v1.1";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 192);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(160, 16);
			this.label2.TabIndex = 3;
			this.label2.Text = "About the Connected MQ:";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(9, 56);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(175, 16);
			this.label3.TabIndex = 5;
			this.label3.Text = "About this .NET Framework App:";
			// 
			// listBox2
			// 
			this.listBox2.Location = new System.Drawing.Point(9, 72);
			this.listBox2.Name = "listBox2";
			this.listBox2.Size = new System.Drawing.Size(296, 69);
			this.listBox2.TabIndex = 4;
			// 
			// AboutBox
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(314, 325);
			this.ControlBox = false;
			this.Controls.Add(this.label3);
			this.Controls.Add(this.listBox2);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.listBox1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "AboutBox";
			this.Text = "About ";
			this.ResumeLayout(false);

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e) {
			this.Close();
		}
	}
}
